%{!?__python2: %global __python2 %{__python}}

%define gitrev f8a75ae

%define relnum 3
%define relval %{?gitrev:0.%{relnum}.%{gitrev}}%{?!gitrev:%{relnum}}

Name:           rpm-depgen-pythondistdeps
Version:        0.3
Release:        %{relval}%{?dist}
Summary:        RPM dependency generator using python egg/wheel data

License:        LGPLv2.1+
URL:            http://rpm.org
# The actual dependency generator
Source0:        https://raw.githubusercontent.com/rpm-software-management/rpm/%{gitrev}/scripts/pythondistdeps.py
# The attr file to use it
Source1:        pythondistdeps.attr
BuildArch:      noarch
%if 0%{?fedora} >= 23
BuildRequires:  python3-devel
%else
BuildRequires:  python2-devel
%endif
# Replaces old rpm-depgen-pythoneggs package
Obsoletes:      rpm-depgen-pythoneggs < %{version}-%{release}
Provides:       rpm-depgen-pythoneggs = %{version}-%{release}

# Do not allow installation on systems with RPM 4.13.90 or newer
Conflicts:      rpm >= 4.13.90

# Do not require Python 2 when not necessary
AutoReq:        no
%if 0%{?fedora} >= 23
Requires:       python3
%else
Requires:       python2
%endif

%description
Pulled from RPM git, this new optional dependency generator
reads Python .egg-info/.egg-link/.dist-info data to generate
pythonX.Ydist() dependencies much like the rubygem() or perl()
dependencies.

%prep
# Nothing to prep


%build
# Nothing to build

%install
mkdir -p %{buildroot}%{_rpmconfigdir}/fileattrs
install -pm 0755 %{SOURCE0} %{buildroot}%{_rpmconfigdir}/pythondistdeps.py
install -pm 0644 %{SOURCE1} %{buildroot}%{_rpmconfigdir}/fileattrs/pythondistdeps.attr

%if 0%{?fedora} >= 23
sed -i "s:@PYINTERPRETER@:%{__python3}:g" %{buildroot}%{_rpmconfigdir}/fileattrs/pythondistdeps.attr
%else
sed -i "s:@PYINTERPRETER@:%{__python2}:g" %{buildroot}%{_rpmconfigdir}/fileattrs/pythondistdeps.attr
%endif

# Enable majorver provides on Fedora
# But don't on EL, because multiple Python versions
# in a major version series do show up from time to time
%if 0%{?fedora}
sed -i "s/@EXTRA_OPTS@/--majorver-provides/g" %{buildroot}%{_rpmconfigdir}/fileattrs/pythondistdeps.attr
%else
sed -i "s/@EXTRA_OPTS@//g" %{buildroot}%{_rpmconfigdir}/fileattrs/pythondistdeps.attr
%endif

%files
%defattr(-,rpm,rpm,-)
%{_rpmconfigdir}/pythondistdeps.py
%{_rpmconfigdir}/fileattrs/pythondistdeps.attr
%if 0%{?fedora} >= 23
%exclude %{_rpmconfigdir}/__pycache__
%else
%exclude %{_rpmconfigdir}/pythondistdeps.pyc
%exclude %{_rpmconfigdir}/pythondistdeps.pyo
%endif

%changelog
* Tue Apr 12 2016 Neal Gompa <ngompa13{%}gmail{*}com> - 0.3.0.3.f8a75ae
- Turn on pythonXdist(M) Provides for Fedora

* Sun Apr 10 2016 Neal Gompa <ngompa13{%}gmail{*}com> - 0.3-0.2.f8a75ae
- Slight correctionns to pythondistdeps.attr
- Adjust conflicts to prevent installation with rpm 4.13.90

* Thu Mar  3 2016 Neal Gompa <ngompa13{%}gmail{*}com> - 0.3-0.1.f8a75ae
- Update to latest code included in RPM git master

* Sat Nov 21 2015 Neal Gompa <ngompa13{%}gmail{*}com> - 0.2-0.1.c8da4c2
- Update to new code submitted for PR
- Switch from pythonXegg() to pythonX.Ydist()

* Mon Nov 16 2015 Neal Gompa <ngompa13{%}gmail{*}com> - 0.1-0.4.a8accc3
- Fix sed expression and simplify attr setup

* Mon Nov 16 2015 Neal Gompa <ngompa13{%}gmail{*}com> - 0.1-0.3.a8accc3
- Replace python-macros BR with versioned python-devel

* Mon Nov 16 2015 Neal Gompa <ngompa13{%}gmail{*}com> - 0.1-0.2.a8accc3
- Add python-macros BuildRequires

* Mon Nov 16 2015 Neal Gompa <ngompa13{%}gmail{*}com> - 0.1-0.1.a8accc3
- Initial packaging
